Bug 1258542 - Review Request: hack-fonts - A typeface designed for source code
Summary: Review Request: hack-fonts - A typeface designed for source code
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Shawn Starr
QA Contact: Shawn Starr
URL:
Whiteboard:
Depends On: 1440971 1441023
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-08-31 15:21 UTC by Helio Chissini de Castro
Modified: 2019-05-05 08:42 UTC (History)
24 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed:
helio: fedora-review?


Attachments (Terms of Use)

Description Helio Chissini de Castro 2015-08-31 15:21:00 UTC
Spec URL: https://heliocastro.fedorapeople.org/hack-fonts.spec
SRPM URL: https://heliocastro.fedorapeople.org/hack-fonts-2.010-1.fc22.src.rpm
Description: A typeface designed for source code
Fedora Account System Username: heliocastro

Comment 1 Adam Williamson 2015-09-01 01:02:11 UTC
From the policy: "Fonts SHOULD be built from source whenever upstream provides them in a source format" - upstream does appear to provide source here.

Comment 2 Helio Chissini de Castro 2015-09-01 12:18:45 UTC
Yep

They have the source, but no instructions how to build it whatsoever.
I just followed the same process used on Overpass Red Hat font, which has the source available, but same way, only the type faces are included.

Comment 3 Arun Raghavan 2015-09-08 05:49:12 UTC
Relevant: https://github.com/chrissimpkins/Hack/issues/85

Comment 4 Christopher Meng 2015-09-08 08:30:11 UTC
NEW version released.

Comment 5 Nicolas Mailhot 2015-09-08 09:27:28 UTC
(In reply to Helio Chissini de Castro from comment #2)
> Yep
> 
> They have the source, but no instructions how to build it whatsoever.
> I just followed the same process used on Overpass Red Hat font, which has
> the source available, but same way, only the type faces are included.

This is ridiculous, the fonts are derived from DejaVu, and DejaVu build is completely scripted. The project just need to fork the build scripts like it forked everything else, and decide on a naming policy

Comment 6 Fabio Alessandro Locati 2015-10-03 18:21:38 UTC
I really hope to see this package in the main repo soon :)

Comment 7 Shawn Starr 2015-10-21 16:21:52 UTC
Where are we in this review? Upstream is excited to get Hack into Fedora.

Comment 9 Shawn Starr 2016-02-09 23:58:19 UTC
Any further update on this?

Comment 10 Gwyn Ciesla 2016-10-07 13:25:55 UTC
Package request has been denied with the reason: Review not approved.

Comment 11 Gwyn Ciesla 2016-10-07 13:26:30 UTC
Package request has been denied with the reason: Review not approved.

Comment 12 Gwyn Ciesla 2016-10-07 13:27:06 UTC
Package request has been denied with the reason: Review not approved.

Comment 13 Gwyn Ciesla 2016-10-07 13:27:37 UTC
Package request has been denied with the reason: Review not approved.

Comment 14 Gwyn Ciesla 2016-10-07 13:29:06 UTC
Package request has been denied with the reason: Review not approved.

Comment 15 Gwyn Ciesla 2016-10-07 13:30:07 UTC
Package request has been denied with the reason: Review not approved.

Comment 16 Shawn Starr 2016-10-08 03:48:35 UTC
I will do review since I want this font already. Expect a review for tomorrow.

Comment 17 Shawn Starr 2016-10-08 03:49:26 UTC
I'll just take this over if nobody is doing this, will ask for a review.

Comment 18 Helio Chissini de Castro 2016-10-08 06:36:55 UTC
Thanks Shawn.
This was strangely forgotten.

Comment 19 Shawn Starr 2016-10-09 04:53:07 UTC
Before we can even move to package this, does anyone know how this is built? I've opened a ticket on upstream's github, Debian has this packaged but I don't see them doing any source builds of the fonts.

I need some clarification on our policy for this. Given Debian is even more severe for requiring sources, maybe Fedora should follow Debian's guide on this?

Comment 20 Helio Chissini de Castro 2016-10-10 06:40:13 UTC
Debian is using same approach as me, using the precompiled ttf/otf
The only thing is that we're deploying only ttf and debian both ones.

And i personally don't know if worth pack the web fonts.

Comment 21 Shawn Starr 2016-10-10 09:26:54 UTC
Well, if it's acceptable to Debian surely this should be acceptable to Fedora, if not something seems wrong with our policy...

Comment 22 Adam Williamson 2016-12-23 00:04:48 UTC
Debian is not inevitably 'freer' than Fedora. Our requirements are more strict in some ways. Just because Debian doesn't (and, AFAICT, never has) required fonts to be compiled from source doesn't mean we're wrong in requiring this.

Comment 23 Peter Oliver 2016-12-29 23:17:07 UTC
Upstream bug regarding building this font from source: https://github.com/chrissimpkins/Hack/issues/227

Comment 24 Shawn Starr 2017-01-01 22:33:53 UTC
I am in contact with upstream, they are looking at improving our ability to build the fonts from scratch. More on this when they get back to me.

Comment 25 Randy Barlow 2017-04-18 21:00:53 UTC
The Hack license is now acceptable for Fedora:

https://lists.fedoraproject.org/archives/list/legal@lists.fedoraproject.org/thread/MJ4Q3D6JLDVX4OHSF3YXY76Z6BYSKKQR/

Also, FWIW I could really use the web fonts for Bodhi (which is why I wanted to package Hack) so I would appreciate if you could include a subpackage with those files.

I'm willing to review this package if nobody else has a "claim" on reviewing it.

Comment 26 Randy Barlow 2017-04-18 21:10:47 UTC
After reading the scrollback it does sound like Shawn is lined up to do the review so I'll defer, but I'm happy to be a standin. I'll memorize my lines.

My interpretation of the packaging rules is that SHOULD != MUST when it comes to building the font from source. The font guidelines do use the word "MUST" in other places so I take that to mean that this shouldn't block the package from getting into Fedora. It's obviously better if we build the font from source, but since there isn't a clear way to do that provided by upstream I don't think we have to wait for https://github.com/chrissimpkins/Hack/issues/227 to be solved to get this into Fedora. I would recommend allowing the package in with the OTF files (and hopefully web files for me ☺) and then filing a BZ to build from source if possible later.

Comment 27 Adam Williamson 2017-04-18 21:16:23 UTC
Well, there's still the *general* packaging guidelines to consider. I don't think the font guidelines supersede those, in fact the section on packaging from source specifically references back to them. And they're quite specific about when you get an exception from the requirement to build from source.

Comment 28 Shawn Starr 2017-04-18 22:09:18 UTC
I've poked Chris on twitter, you can certainly help with packaging, it's always good to have co-maintainers.

Comment 29 Randy Barlow 2017-04-19 16:20:50 UTC
Adam, fair enough.

Shawn, if you don't want to deal with the web files I'd be happy to handle that part as a co-maintainer.

Comment 30 Shawn Starr 2017-04-24 05:56:13 UTC
Here is the tool can use to build the fonts

https://github.com/GoogleI18N/fontmake

We will need this packaged too as a dependency for building, if we want to build them now.

Comment 31 rugk 2017-05-21 15:04:48 UTC
Any news here?

Comment 32 Shawn Starr 2017-05-21 19:30:43 UTC
I should have something soon, i'll put up a .spec for review this week.

Comment 33 Jason Tibbitts 2017-07-25 16:45:07 UTC
So I see this is still pending and I'm not completely sure why.

I understand that there's a desire to have these built from source, which requires some additional dependencies.  However, fonts are considered by Fedora to be "content" and are explicitly listed as content: https://fedoraproject.org/wiki/Packaging:Guidelines#Code_Vs_Content

The font-specific packaging guidelines mention that they should be compiled from source because most of the time they are buildable with free, packaged software and the existence of bytecode hinting engines does get close to the line of what might start looking like something which isn't content.  However, it's just a "should", and lack of software needed to build it is a pretty good reason to violate one of those.

If anything I'd hope that the hack fonts could be imported now while work is ongoing to package the dependencies.  In the future this package could switch over to building from source.

If the guidelines on this are confusing then I will be happy to work to get them changed to be less confusing.

Comment 34 Shawn Starr 2017-07-25 21:27:18 UTC
Upstream is changing how fonts are built now, which means we can use Open Source tools to build them. I'm waiting for them to finish some of those bits which are im progress right now.

Comment 35 Shawn Starr 2017-08-29 18:12:27 UTC
This is currently blocked from our other dependencies needed for python-fontmake and its sub-dependencies...

Upstream is appreciative in our efforts to get things packaged up.

Comment 36 Shawn Starr 2017-10-20 16:21:08 UTC
Note:

https://github.com/source-foundry/Hack/blob/master/CHANGELOG.md

3.00 is released, but we're still blocked here...

Comment 37 Shawn Starr 2018-02-18 02:25:53 UTC
Not forgotten... I am seeing the reviews blocking this are getting closer to being done.

Comment 38 Jamie Mansfield 2018-11-01 17:36:41 UTC
I've been working on getting Hack packaged in a satisfactory manor (I hope), its not 100% working yet - trouble at the last step (always the way -_-).

My solution to the lack of a 'fontmake' package, is to grab the dependencies from pip (in a virtual environment). This can easily be swapped out for the proper 'fontmake' package when the time comes.

This isn't a perfect solution, but it does solve the issue of compiling the font ourselves - input on this would be appreciated :) Hopefully we can get this into the repository swiftly.

On a final note, I haven't based this work of the original spec presented in this issue (I'd already begun working on my own) - looking at the original, there does seem to be some outstanding issues with it that are resolved by mine:
- The source URL seems be be wrong on the original, referring to an old version (perhaps GitHub allows such dodgy usage)
- Some of the metadata seems to be filled in wrong, specifically with regards to the licensing

Repository: https://pagure.io/hack-fonts
SPEC File:  https://pagure.io/hack-fonts/raw/master/f/hack-fonts.spec

Comment 39 Adam Williamson 2018-11-01 17:46:31 UTC
That's not acceptable under Fedora policies, I don't think. (As written it simply would not *work*, either, when you tried an official package build, as - by design - package builds run without network access).

Comment 40 Jamie Mansfield 2018-11-01 18:12:13 UTC
Huh, wasn't aware of the package builds running without network access - will need to wait for fontmake to be introduced to a package then :S

At least the work is easily adaptable for when that happens - I'll look into the issue I'm having with ttfautohint and it should be a case of adding the appropriate required package.

Comment 41 Shawn Starr 2018-11-03 19:06:40 UTC
Yes, this is where we are at and why I've not been able to move on this...


Note You need to log in before you can comment on or make changes to this bug.